package com.company.test.web.screens.employee;

import com.company.test.entity.Gender;
import com.haulmont.cuba.gui.icons.CubaIcon;
import com.haulmont.cuba.gui.screen.*;
import com.company.test.entity.Employee;

@UiController("test_Employee.browse")
@UiDescriptor("employee-browse.xml")
@LookupComponent("employeesTable")
@LoadDataBeforeShow
public class EmployeeBrowse extends StandardLookup<Employee> {

    @Install(to = "employeesTable", subject = "iconProvider")
    private String employeesTableIconProvider(Employee employee) {
        if (Gender.MALE.equals(employee.getGender())) {
            return CubaIcon.MALE.source();
        } else if (Gender.FEMALE.equals(employee.getGender())) {
            return CubaIcon.FEMALE.source();
        } else if (Gender.DIVERSE.equals(employee.getGender())) {
            return CubaIcon.ODNOKLASSNIKI.source();
        } else {
            return null;
        }
    }



}